2005-01-18  tag aolserver_v40_r10

2005-01-18  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.19): Added missing prototype for
	  Ns_CompressGzip.

	  BUMP: 4.0.10

2005-01-12  Dossy Shiobara <dossy@panoptic.com>

	* nsd/nsd.h (1.77.2.8), nsd/adpcmds.c (1.14.2.1), nsd/adprequest.c
	  (1.16.2.2), nsd/compress.c (1.1.2.3), nsd/server.c (1.27.2.1),
	  nsd/tclcmds.c (1.38.2.1), tests/new/http-test-config.tcl
	  (1.1.2.2), tests/new/ns_adp_compress.test (1.1.2.1),
	  tests/new/servers/server1/pages/ns_adp_compress.adp (1.1.2.1):
	  Support on-the-fly gzip compression of ADP page responses based
	  on HTTP request's Accept-Encoding header and ns_adp_compress
	  control mechanism.

2004-12-01  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.17): Provide NS_VERSION_NUM definition to
	  make conditionalized testing of AOLserver version at build time
	  easy.

2004-11-22  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.16): BUMP: 4.0.10a

2004-11-22  tag aolserver_v40_r9

2004-11-22  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.15): BUMP: 4.0.9

2004-11-20  Dossy Shiobara <dossy@panoptic.com>

	* nsd/tclsched.c (1.5.2.1): Option parsing needed to be more
	  careful, leading to segfaults when a bad command like
	  [ns_schedule_proc -thread -only] is executed.  Closes SF Bug
	  #1068836.   Backport from HEAD.

2004-11-19  Dossy Shiobara <dossy@panoptic.com>

	* configure (1.15.2.8), configure.in (1.13.2.6): autoconf now
	  detects if libgcc is built shared, in which case LIBS needs
	  -lgcc_s.  Without it, the nsd binary will fail to link because of
	  unresolved symbols __umoddi3 and __udivdi3 in nsd/dsprintf.c.

2004-11-19  Dossy Shiobara <dossy@panoptic.com>

	* nsd/Makefile (1.39.2.2): Adding -lz to LIBS is now redundant.

2004-11-19  Dossy Shiobara <dossy@panoptic.com>

	* include/nsthread.h (1.24.2.4): Need to include <inttypes.h> on
	  some platforms (OS X, Solaris 10) to get C99 "uint32_t" and other
	  types.  Backport from HEAD.

2004-11-19  Dossy Shiobara <dossy@panoptic.com>

	* configure (1.15.2.7), configure.in (1.13.2.5),
	  include/Makefile.global.in (1.16.2.1), nsd/compress.c (1.1.2.2):
	  Add --with-zlib configure option (on by default) and add ifdef's
	  to nsd/compress.c.  Backport from HEAD.

2004-11-17  Dossy Shiobara <dossy@panoptic.com>

	* nsd/adprequest.c (1.16.2.1): Don't send Content-Length if
	  streaming is on.  Backport from HEAD.

2004-11-15  Dossy Shiobara <dossy@panoptic.com>

	* nsd/nsmain.c (1.52.2.3): AOLserver will now allow setting the fd
	  limit (via "ulimit -Hn", etc.) and only log a warning if it
	  exceeds FD_SETSIZE.  Do this at your own risk, as things which
	  still use select(), i.e., Tcl, are likely to break.  Backported
	  from HEAD.

2004-11-05  Dossy Shiobara <dossy@panoptic.com>

	* nsd/sockcallback.c (1.12.2.3): Dereferencing cbPtr->nextPtr is
	  dangerous since cbPtr could have been freed.

2004-09-30  tag aolserver_v40_r9_b2

2004-09-30  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.13): BUMP: 4.0.9b

2004-09-30  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.12), nsd/tclhttp.c (1.16.2.5),
	  nsd/sockcallback.c (1.12.2.2): Implement
	  Ns_SockCancelCallbackEx() in order to correctly cancel actions in
	  the SockCallbackThread.  Fix for SF Bug #1037196.  Backported
	  from HEAD for 4.0.9.

2004-09-29  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.11), nsd/tclhttp.c (1.16.2.4),
	  nsd/sockcallback.c (1.12.2.1): Fix a thread hang issue when
	  ns_http fails but HttpCancel() never executes because poll()
	  returns revent == POLLPRI.  Closes SF Bug #1037196.  Backported
	  from HEAD for 4.0.9.

2004-09-24  Dossy Shiobara <dossy@panoptic.com>

	* include/nsthread.h (1.24.2.2): Win32 supports the
	  get{addr,name}info() API, so use it.	Backported from HEAD for
	  4.0.9.

2004-09-24  Dossy Shiobara <dossy@panoptic.com>

	* nsd/dns.c (1.7.2.3): Small memory leak introduced on platforms w/
	  getaddrinfo.	Closes SF Bug #1033575.  Backport from HEAD for
	  4.0.9.

2004-09-22  Dossy Shiobara <dossy@panoptic.com>

	* configure (1.15.2.6), configure.in (1.13.2.4): get{addr,name}info
	  on Solaris 9 is in -lsocket.	Backported from HEAD.

2004-09-21  Dossy Shiobara <dossy@panoptic.com>

	* configure (1.15.2.5), configure.in (1.13.2.3): Ensure we use the
	  compiler from the Tcl build during AOLserver configure process,
	  unless it's explicitly overrided during the AOLserver build.
	  Backported from HEAD for 4.0.9.

2004-09-21  Dossy Shiobara <dossy@panoptic.com>

	* aclocal.m4 (1.1.4.3): Make detection of gethostby{addr,name}_r
	  more robust.	Closes SF Bug #1032231.  Backported from HEAD for
	  4.0.9.

2004-09-20  Dossy Shiobara <dossy@panoptic.com>

	* nsd/: nsmain.c (1.52.2.2), nsd.h (1.77.2.7), unix.c (1.15.2.5):
	  Need to set the dumpable flag on Linux in order to get a core
	  file after uid/gid is changed.  Closes SF Bug #1031599.
	  Backported from HEAD for 4.0.9a.

2004-09-17  Dossy Shiobara <dossy@panoptic.com>

	* nsd/connio.c (1.12.2.2): Ns_ConnSend() now bubbles up the error
	  from NsSockSend() on first send,	   which is what the C API
	  documentation says.  Closes SF Bug #1029512.	Backported from
	  HEAD for 4.0.9a.

2004-09-17  Dossy Shiobara <dossy@panoptic.com>

	* nsd/driver.c (1.17.2.9): "stopped" already initalized to 1, which
	  means NsWaitDriversShutdown() will never timeout even when it
	  should, which means trigPipe always gets closed immediately which
	  causes DriverThread to Ns_Fatal() on line 848.  Closes SF Bug
	  #1029918.

2004-09-08  Dossy Shiobara <dossy@panoptic.com>

	* nslog/nslog.html (1.1.10.1): Updated nslog module documentation.
	  Closes SF Bug #466236.  Backported from HEAD.

2004-09-08  Dossy Shiobara <dossy@panoptic.com>

	* nscgi/nscgi.html (1.1.10.2): Add datatype for config options to
	  doc.	Backported from HEAD.

2004-09-07  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.10): BUMP: 4.0.9a

2004-09-07  tag aolserver_v40_r8

2004-09-07  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.9): BUMP: 4.0.8

2004-09-07  Dossy Shiobara <dossy@panoptic.com>

	* README (1.4.2.1): Updated for 4.0.8.

2004-09-03  Dossy Shiobara <dossy@panoptic.com>

	* nscgi/nscgi.html (1.1.10.1): Updated nscgi module documentation
	  for 4.0.  Closes SF Bug #465907.  Backported from HEAD.

2004-08-25  Dossy Shiobara <dossy@panoptic.com>

	* nsd/queue.c (1.23.2.1): If reqPtr is NULL, close the connection
	  too.

2004-08-25  Dossy Shiobara <dossy@panoptic.com>

	* nsd/driver.c (1.17.2.8): Previous code to eat leading blanks
	  assumed CR/LF, but some clients only send LF.  Code has been
	  cleaned up and corrected to handle this properly.

2004-08-20  Dossy Shiobara <dossy@panoptic.com>

	* Makefile (1.44.2.2), tests/new/all.tcl (1.1.2.1),
	  tests/new/harness.tcl (1.2.2.1), tests/new/ns_hrefs.test
	  (1.1.2.1), tests/new/test-ns_addrbyhost.adp (1.1.2.1),
	  tests/new/test-ns_hostbyaddr.adp (1.1.2.1),
	  tests/new/test-ns_hrefs.adp (1.1.2.1): Implement automated tests
	  that can be run from a stand-alone tclsh.  New Makefile target
	  added called "test" which runs the tests.

2004-08-18  Dossy Shiobara <dossy@panoptic.com>

	* tcl/fastpath.tcl (1.8.2.2): If _ns_dirlist gets an URL without a
	  trailing slash, issue a 302 redirect back to the same url WITH
	  the trailing slash.  Fixes SF Bug #935907.  Backported from HEAD.

2004-08-17  Dossy Shiobara <dossy@panoptic.com>

	* nsd/fastpath.c (1.18.2.2): Minor change to eliminate Win32
	  compile-time warning.  Closes SF Bug #696806.  Backported from
	  HEAD.

2004-08-14  Dossy Shiobara <dossy@panoptic.com>

	* aclocal.m4 (1.1.4.2), configure (1.15.2.3), nsd/dns.c (1.7.2.2):
	  Solaris 7 uses gethostbyaddr_r(), and the autoconf and GetHost()
	  versions didn't work.  Fixed now.  Backported from HEAD.

2004-08-14  Dossy Shiobara <dossy@panoptic.com>

	* nsd/dns.c (1.7.2.1), aclocal.m4 (1.1.4.1), configure.in
	  (1.13.2.2), configure (1.15.2.2): gethostbyaddr() and
	  gethostbyname() are not thread-safe.	Use the new getaddrinfo()
	  and getnameinfo() API where available, otherwise use
	  gethostbyaddr_r() and gethostbyname_r() if available.  Otherwise,
	  continue to use the non-safe versions but emit a warning at
	  configure time.  Fixes SF Bug #1008721.  Backported from HEAD.

2004-08-13  Dossy Shiobara <dossy@panoptic.com>

	* win32/: nscgi/nscgi.dsp (1.5.2.1), nscp/nscp.dsp (1.5.2.1),
	  nsd/nsd.dsp (1.14.2.1), nsdb/nsdb.dsp (1.1.2.1), nslog/nslog.dsp
	  (1.5.2.1), nsperm/nsperm.dsp (1.5.2.1), nssock/nssock.dsp
	  (1.8.2.1), nsthread/nsthread.dsp (1.7.2.1),
	  threadtest/threadtest.dsp (1.5.2.1): Change Win32 .dsp files to
	  reflect change in Tcl from "tcl84td.lib" to "tcl84tg.lib".  Fixes
	  SF Bug #996342.  Backported from HEAD.

2004-08-13  Dossy Shiobara <dossy@panoptic.com>

	* nsd/tclmisc.c (1.30.2.1): ns_hrefs is now more robust.  Fixes SF
	  Bug #995078.	Backported from HEAD.

2004-08-11  Dossy Shiobara <dossy@panoptic.com>

	* nsd/nsconf.c (1.32.2.3): Inability to resolve nsconf.hostname to
	  set nsconf.address is no longer fatal, and instead defaults to
	  "0.0.0.0".  Fixes SF Bug #994072.  Backported from HEAD.

2004-08-11  Dossy Shiobara <dossy@panoptic.com>

	* nsd/driver.c (1.17.2.7): Fixed crash bug when virtual servers are
	  configured, but the "hostname" parameter didn't match any of the
	  virtual servers.  Fixed by introducing new "defaultserver"
	  parameter in the comm. config that must refer to one of the
	  virtual servers being defined.  Backported from HEAD.

2004-08-11  Dossy Shiobara <dossy@panoptic.com>

	* sample-config.tcl (1.11.2.2): Add "defaultserver" parameter in
	  sample config.  Backported from HEAD.

2004-08-05  Rob Crittenden <rcrittenden0569@aol.com>

	* nsd/tclhttp.c: Add new option to ns_http wait, -servicetime, so
	  you can capture how long the HTTP request took.

2004-07-28  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.8): BUMP: 4.0.8a

2004-07-28  Dossy Shiobara <dossy@panoptic.com>

	* configure (1.15.2.1), configure.in (1.13.2.1): Clean up
	  configure.in, regenerate configure with autoconf2.13, and clear
	  CCRPATH/LDRPATH if CCRFLAGS/LDRFLAGS are empty.  Closes SF Bug
	  #640754.  Backported from HEAD.

2004-07-19  tag aolserver_v40_r7

2004-07-19  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.7, aolserver_v40_r7): BUMP: 4.0.7

2004-07-18  Dossy Shiobara <dossy@panoptic.com>

	* nsd/return.c (1.33.2.6): Fix bug where internal redirect for 401
	  omitted including the HTTP auth.  "WWW-Authenticate:" header.
	  Fixes bug #674033.  Backported from HEAD.

2004-07-18  Dossy Shiobara <dossy@panoptic.com>

	* nsd/: nsd.h (1.77.2.6), init.c (1.5.2.1), nsconf.c (1.32.2.2):
	  Ns_GetAddrByHost() reports errors via Ns_Log(), so calls to it
	  should be done after Ns_Log has been initialized, otherwise very
	  unhelpful error messages are produced.  In particular, this
	  happens when the server is started and the hostname as returned
	  by gethostname() cannot be resolved, because the network
	  interface is down AND no entry exists in /etc/hosts.	Closes SF
	  Bug #868362.	Backported from HEAD.

2004-07-16  Dossy Shiobara <dossy@panoptic.com>

	* nsd/driver.c (1.17.2.6): Setting request->method to static
	  storage, which later gets ns_free()'d in Ns_FreeRequest(), caused
	  server to crash.

2004-07-16  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.6): BUMP: 4.0.7a

2004-07-16  tag aolserver_v40_r6

2004-07-16  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h (1.55.2.5): BUMP: 4.0.6

2004-07-15  Tim Suh <suhti@aol.com>

	* nsd/return.c: keepalive is enabled for response codes other than 200 

2004-07-13  Dossy Shiobara <dossy@panoptic.com>

	* nsd/: driver.c (1.17.2.5), op.c (1.11.2.1): Change to make HTTP
	  request "Host:" header mandatory for HTTP/1.1 connections by
	  returning 400 Bad Request response.  Closes SF Bug #787728.
	  Also, changed virtual server code to use the "hostname" param
	  from the "ns/module/nssock" section to map the default virtual
	  server based on the value (hostname) from the
	  "ns/module/nssock/servers" section, when the "Host:" header is
	  either not specified (HTTP/1.0) or is not found in the virtual
	  server table.  Closes SF Bug #812036.  Backport from HEAD, but
	  not straight patch due to difference in conn/request handling in
	  4.0 vs. 4.1.

2004-07-13  Dossy Shiobara <dossy@panoptic.com>

	* nslog/nslog.c (1.14.2.1): conn->headers can be NULL causing
	  segfault.  Closes SF Bug #990439.  Backported from HEAD.

2004-07-13  Dossy Shiobara <dossy@panoptic.com>

	* include/nsthread.h (1.24.2.1): OpenBSD 3.5 doesn't define
	  ENOTSUP, so we'll define it ourselves.  Closes SF Bug #985076.
	  Backported from HEAD.

2004-07-02  Dossy Shiobara <dossy@panoptic.com>

	* nsd/mimetypes.c (1.11.2.1): Ns_GetMimeType() was returning
	  defaultType instead of noextType if the path contained a
	  directory with a "." but the filename component had no extension.
	  Fixes bug #739049.  Backported from HEAD.

2004-07-02  Dossy Shiobara <dossy@panoptic.com>

	* nsd/: fastpath.c (1.18.2.1), return.c (1.33.2.4): Enable ADP/Tcl
	  code to override Last-Modified: header from ns_respond when
	  -headers AND -file are specified.  Closes bug #879076.  Backport
	  from HEAD, for 4.0.6.

2004-07-02  Dossy Shiobara <dossy@panoptic.com>

	* nsd/tclresp.c (1.16.2.1): lots of refactoring of ns_respond code
	  to remove duplication.  Backport from HEAD.

2004-07-02  Dossy Shiobara <dossy@panoptic.com>

	* nsd/init.tcl (1.30.2.1): ns_eval of script containing comments
	  (i.e., lines starting with "#") cause an error because $args is a
	  list, which gets evaluated differently than a plain string
	  script.  Fixes bug #833940.  Backported from HEAD.

2004-07-01  Dossy Shiobara <dossy@panoptic.com>

	* nsd/: nsd.h (1.77.2.5), nsmain.c (1.52.2.1): Ensure that
	  supplementary groups from /etc/group are set if -u username is
	  specified, or dropped if a uid is specified so that the nsd
	  doesn't run with root's supplementary groups.  Closes bug
	  #425401.  Backport from HEAD.

2004-07-01  Dossy Shiobara <dossy@panoptic.com>

	* nsd/nsd.h (1.77.2.4): trivial - eliminate compiler warning for
	  nsd/nsmain.c

2004-07-01  Dossy Shiobara <dossy@panoptic.com>

	* nsthread/tls.c (1.2.2.1): Make the Tcl_Panic() message from
	  Ns_TlsGet() and Ns_TlsSet() include the full function name to aid
	  in debugging.  (Backport from HEAD.)

2004-06-30 17:20  Dossy Shiobara <dossy@panoptic.com>

	* nsd/unix.c: Ensure synchronous signals are handled correctly
	  under LinuxThreads.  Possible fix for Bug #982955.

	  Backported from HEAD for 4.0.6.

2004-06-30 01:24  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h: Fix build on alpha arch, removing extra INT64
	  typedef.  Closes bug #896962. (Backport from HEAD.)

2004-06-23  Rob Crittenden <rcrittenden0569@aol.com>

	* nsd/log.c: ns_log now logs to a custom logger as well.

2004-06-14 20:41  Dossy Shiobara <dossy@panoptic.com>

	* nsd/return.c: unnecessary test for data != NULL actually caused
	  part of bug #971016 when fastpath.cache=false and
	  fastpath.mmap=true and the file requested is zero bytes, mmap()
	  returns 0 which gets passed along as data == NULL, causing
	  ReturnCharData() to not flush the queued headers.  removing the
	  if is safe as Ns_WriteConn will simply flush any queued data

2004-06-14 20:40  Dossy Shiobara <dossy@panoptic.com>

	* nsd/connio.c: If nsend == 0, we would never call Ns_WriteConn to
	  flush the queued headers.  This could happen when we're sending
	  zero bytes of data as a response.  This fixes bug #971016 in the
	  case where fastpath.cache=false and fastpath.mmap=false and a
	  zero byte file is requested.

2004-06-14 16:40  Dossy Shiobara <dossy@panoptic.com>

	* nsd/return.c: one-liner fix for sending Content-Length header
	  for content of zero bytes (Bug #971016)

2004-06-03  Rob Crittenden <rcrittenden0569@aol.com>

    * TAG aolserver_v40_r5

2004-06-03  Rob Crittenden <rcrittenden0569@aol.com>

	* Makefile: remove Makefile.module during distclean
	* include/ns.h, nsd/log.c: Allow users to override logging functions.
	* nsd/str.c: Fix crash bug in Ns_Trim* when trimming NULL strings.
	* nsd/: nsconf.c, driver.c, return.c, nsd.h: Add new bool config
	  option, keepaliveallmethods, which enables HTTP/1.0 Keep-Alives for
	  all valid methods. By default this is false.

2004-03-26  Mark Page  <mpagenva@aol.com>

	* nsd/nsd.h:
	* nsd/driver.c:
	* sample-config.tcl: Add configurable logging of errors which cause the
	driver to drop a incoming connection socket.  Logging goes to the
	server log.  Following new bool config params are added to the socket
	driver's section (e.g., nssock, etc): readtimeoutlogging,
	serverrejectlogging, sockerrorlogging,
	sockshuterrorlogging.
	
2004-02-27 14:14  Dossy Shiobara <dossy@panoptic.com>

	* include/ns.h: fix for bug #906011 "include/ns.h version not
	  bumped"

2004-02-26 14:37  Dossy Shiobara <dossy@panoptic.com>

	* nsd/unix.c: uid_t is supposed to be unsigned, but apparently
	  isn't on OSX, apparently.

2004-02-19 13:22  Dossy Shiobara <dossy@panoptic.com>

	* nsdb/: dbinit.c, dbtcl.c: fix "ns_db gethandle -timeout" so that
	  when timeout < 0 it blocks forever, timeout == 0 is poll, and
	  timeout > 0 times out after timeout seconds

2004-02-18 11:35  Dossy Shiobara <dossy@panoptic.com>

	* nsperm/nsperm.c: fixed bug #899364, restoring old nsperm
	  functionality as it was in 3.x.

2003-11-23  mpagenva <mpagenva@aol.com>
        * nsd/tclhttp.c: remove validity check on method param to ns_http 
          queue, since methods in addition to put and post can be valid.
        * tcl/fastpath.tcl: make configuable: a) logging to serverlog
          fastpath update requests (some configs may be fine with the
          logging to the access log which can be easily obtained).
          b) automatic backfill of implied directory tree on put.

2003-11-19  pkhincha <pkhincha@aol.com>
        * maxinput to throttle the # of bytes
        * on request.  
        * Removed ThreadJoin of driver thread.

2003-11-03  pkhincha <pkhincha@aol.com>

	* nsd/urlspace.c: removed initing of mutex
	* nsd/nsmain.c: calling NsWaitDriversShutdown

2003-11-01  Zoran Vasiljevic <zv@archiware.com>

	* tcl/file.tcl: fixed broken argument convention for the
	unused argument of ns_sourceproc.

2003-10-28  Zoran Vasiljevic <zv@archiware.com>

	* nsd/tclatclose.c: fixed typo in command usage text

2003-10-09  Mark Page  <mpagenva@aol.com>

        * TAG aolserver_v4_r0_beta_20
        * doc/ns_job.n:
        * tests/api/ns_job.adp:
        * nsd/tcljob.c: Change timeout specification to be ns_time
        based.
	
2003-10-21  Elizabeth Thomas <eathomas93@aol.com>

	* nsd/init.tcl: Removing lazyproc code from 4.0 to enable it
        to be declared GM. Solution is being refined and may be added 
        in later release or add-on module. 

2003-10-14  Paul Moosman <pwmoosman@aol.com>

	* nsd/tcljob.c: Fix to ns_job, where it was attempting to access
        a deleted queue.

2003-10-09  Mark Page  <mpagenva@aol.com>

        * TAG aolserver_v4_r0_beta_18
	
2003-10-09  Elizabeth Thomas <eathomas93@aol.com>

        * nsd/init.tcl: Fix syntax error in check for null proc.

2003-10-08  Mark Page  <mpagenva@aol.com>

        * TAG aolserver_v4_r0_beta_17
	
	* nsd/init.tcl (ns_eval): Minor change to track change to ns_job.

2003-10-08  Paul Moosman <pwmoosman@aol.com>

	* nsd/tcljob.c: Minor change to ns_job joblist return to be
        consistent with similar aolserver api's.

2003-10-07  Mark Page  <mpagenva@aol.com>

        * TAG aolserver_v4_r0_beta_16
	
	* nsd/init.tcl (ns_eval): The early 4.0 ns_eval had been
	waiting for the completion of integrating script changes into the
	server's init script.  This change adds the ability to return
	without waiting for the init script integration completion (as the
	default).  A new switch modifies this behavior to force it to wait
	for the completion of init script integration.  Added another
	switch to request a report of ns_eval backlog.

	* nsd/adpeval.c (LogError): Limit the amount of script text added
	into the errorInfo string, to keep from flowing adp script texts
	of unlimited length into the server log.

2003-10-06  Paul Moosman <pwmoosman@aol.com>

	* nsd/tcljob.c: Replaced ctime_r with ns_ctime to fix a win32
	compile problem. This change should fix bug #811802.
	Fixed a potential deadlock case.
	Fixed a problem where the maxthreads option was getting ignored.

2003-10-01  Elizabeth Thomas <eathomas93@aol.com>

        * nsd/init.tcl: Fix to _ns_lzproc_load to handle subtle behavior with
        respect to namespaces and the test to see if the proc will be successfully
        recognized. Also, fix to protect against infinite loop on unknown processing
        if null command is executed.

2003-09-22  Mark Page  <mpagenva@aol.com>

        * TAG aolserver_v4_r0_beta_15

2003-09-22  Paul Moosman <pwmoosman@aol.com>

        * nsd/tcljob.c: Add options to ns_job Api, for waitany, delete(queue), 
          listjobs, etc.

2003-09-19  Mark Page  <mpagenva@aol.com>

        * nsd/adprequest.c:
          nsd/adpeval.c: Fix error where 
          xxx.adp --> ns_adp_parse --> ns_adp_include --> ns_adp_puts results in
          the puts text going directly into the final result buffer, rather then
          to the intermediate buffer to be returned by ns_adp_parse to the xxx.adp
          page code.

2003-09-12  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_14

2003-09-11  Elizabeth Thomas  <eathomas93@aol.com>

        * nsd/init.tcl: Add 'lazyproc' functionality. Controlled by 
        ns/parameters config parm 'lazyprocdef' (defaults to 'false')
        When 'true', we do not put proc definitions in the interp
        init script, but instead wrap the tcl 'unknown' command and
        evaluate them on the first reference. Also wraps the tcl 'info'
        command to intercept queries about procs not yet in the interpreter.

2003-09-03  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_13
	* nsd/tclinit.c (NsTclICtlObjCmd): Fix intermittant core dumps
        occurring during oncleanup processing.  The error is in the Tcl_Obj
	for the script passed into ns_ictl on* callbacks was being saved
	and passed to the callbacks (this Tcl_Obj was then being shared 
        amoung Interps, which is not allowed).
	Now, extract a copy of the script string, and pass that to the callbacks.

2003-08-27  Elizabeth Thomas  <eathomas93@aol.com>

	* nsd/adprequest.c: Complete 8/12 fix of not
        logging error for ns_adp_break

2003-08-26  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_12

2003-08-26  Elizabeth Thomas <eathomas93@aol.com>

        * nsd/tclinit.c: Fix the 'oncleanup' option of ns_ictl.
        Modify behavior of Ns_RegisterAtDelete so callbacks are
        run before the interp is destroyed. Expose with new 'ondelete'
        option to ns_ictl.

2003-08-25  Mark Page  <mpagenva@aol.com>

	* nsd/adprequest.c (): Suppress production of the result data for
	requests with SKIPBODY set.
	* nsd/return.c (ReturnCharData): Allow headers to be returned for
	requests with SKIPBODY; e.g., HEAD requests.

2003-08-21  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/tclfile.c: properly detach and attach the Tcl channel
	out and in the current interpreter.

2003-08-19  Rahul Bhargava <rahul032213@aol.com>

        * nsd/return.c: Updated to support HTTP/1.1 Transfer Chunk Encoding 
        Headers only.

2003-08-19  Nathan Folkman <shmooved@aol.com>

        * nsd/return.c: Updated to include status code from: 
        RFC 2616 (Hypertext Transfer Protocol -- HTTP/1.1) and
        RFC 2518 (HTTP Extensions for Distributed Authoring -- WEBDAV).

2003-08-12  Elizabeth Thomas <eathomas93@aol.com>

	* nsd/adprequest.c: Don't log ns_adp_abort or ns_adp_break as errors.

2003-08-08  Elizabeth Thomas <eathomas93@aol.com>

	* nsd/mimetypes.c: 
        * sample_config.tcl: Add support for xhtml mime type. (RFE #563417)

        * TAG aolserver_v4_r0_beta_11

2003-08-06  Elizabeth Thomas <eathomas93@aol.com>

	* nsd/tclset.c: Fix ns_set split argument checking. (#757849)

2003-08-05  Elizabeth Thomas <eathomas93@aol.com>

	* nsd/conn.c:
        * nslog/nslog.c:
        * include/ns.h:
        * sample-config.tcl: Merge in feature from 3.5 branch (with simpler 
        implementation) for logging of request execution time in access log. 

        To turn on feature add:   

        ns_section "ns/server/${servername}/module/nslog"
           ns_param logreqtime true

        By default the option is disabled. If enabled the connection's
        request time will be appended to the access log before the
        extended headers (if configured).

2003-07-18  Elizabeth Thomas <eathomas93@aol.com>

	* nsd/tclinit.c: Add optional mutex to serialize interp initialization.
        With large init scripts and many threads, there is severe malloc 
        lock contention while tcl evaluates the init script (and populates
        its memory pool). Serializing the initialization reduces the thrashing and 
        results in faster startup.

        * nsd/nsconf.c, nsconf.h, nsd.h: Add config variable 'tclinitlock'
        which activates the above. Defaults to false if not specified.

        * TAG aolserver_v4_r0_beta_10

>>>>>>> 1.190
2003-07-18  Mark Page  <mpagenva@aol.com>

	* nsd/adpeval.c (AdpEval): Check adp.outputPtr validity before
	use.  It can get reset within this adp evaluation loop from
	commands like ns_respond (when it does an internal redirect for
	the file not found case).  In this case, it's appropriate that
	further text from this page code is not appended to the result, as
	other code had determined that the result was complete.

2003-07-12  Zoran Vasiljevic <zoran@archiware.com>

	* nslog/nslog.c: the "X-Forwarded-For" header existence is examined
	when logging the remote user. This allows for logging the real
	remote user wnen it commes from some proxy and/or load balancer.
	Thanks for Gustaf Neumann of XOTcl for the patch. This implements  
	the RFE #770054.

2003-07-10  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_9
	
2003-07-01  Mark Page  <mpagenva@aol.com>

	* nsd/init.tcl (ns_eval): Protect against nested ns_eval calls,
	which would otherwise lead to deadlocks.

2003-06-26  Mark Page  <mpagenva@aol.com>

	* nsd/adpeval.c: Fix problem where ns_adp_include was not propogating
        errors.

2003-06-25  Mark Page  <mpagenva@aol.com>

	* nsd/init.tcl: (ns_eval) Fix thread-safety issue with ns_eval,
	where multiple simultanous usages can clobber a change.
	(_ns_getscript) suppress saving the Tcl global variable 'env' into
	the init script.  Tcl's init takes care of 'env', and including it
	into the init script would cause SetEnvs at interp create that are
	unneeded and undesired.

2003-06-18  Mark Page  <mpagenva@aol.com>

	* nsthread/thread.c (Ns_ThreadCreate): Fix typo in Ns_ThreadCreate
	that was causing it to ignore the stacksize parameter.

	* nsd/init.tcl (_ns_eval): Fix ns_eval to prevent it's bleeding of
	unintended Tcl environment change to the global interp state.

2003-06-06  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/queue.c: fixed "connsperthread" config parameter
	as reported in bug item #749801. Default is set to
	"0" i.e. thread will perform unlimited number of
	connections (never exit) unless it's idle timer
	(if configured) expires. 

2003-05-31  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/config.c: uses Ns_TclDestroyInterp instead of the
	Tcl_DeleteInterp.

	* nsthread/nsthreadtest.c:
	* nsd/info.c:
	* nsd/nsmain.c:
	* include/Makefile.module.in:
	* configure:
	* configure.in: added --disable-shared so we can now build the
	nsd image statically.
 
2003-05-31  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/cache.c:
	* include/ns.h:
	* doc/Ns_Cache.3: added C-API for Ns_CacheTryLock as in RFE #725704
	
2003-05-30  Mark Page <mpagenva@aol.com>

	* nsd/tclthread.c: fix problem in ns_thread begindetached api.
        This code was failing to create the new thread as detached.
        Also corrected for the Ns_TclDetachedThread C api.  As a
        result of this change, non-detached threads will return their
        TclEval result to Ns_ThreadExit, making it available to a
        thread join.

2003-05-28  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_8
	
2003-05-28  Mark Page <mpagenva@aol.com>

	* nsd/tclimg.c: Use binary channel to read img (Thanks to Dossy).
        Eliminate double error string; Corrrect compiler warning on Seek.
        * tcl/form.c: Fix to ns_querygetall to suppress null sublists.  Also,
        make the defaulting semantics work as described.

2003-05-24  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/info.c: added workaround for Tcl_GetMemoryInfo() which
	is not defined in Tcl if somebody undefines USE_THREAD_ALLOC.
	Generally, this call should be avoided altogether.

	* nsd/tclinit.c: added call to Tcl_FinalizeThread() in the
	DeleteInterps() to properly finalize Tcl data on thread exit,
 	thus closing the re-appearing memory leak from V3.3 nsd.

2003-05-20  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_7
	
2003-05-20  Mark Page <mpagenva@aol.com>

	* nsd/tclimg.c: Addition error checks in gif size read.
        * nsd/adpcmds.c: Error check calls to ns_adp funcs.
        * nsd/tclinit.c: Error check calls to Ns_TclGetConn and Ns_TclServerInterp.

2003-05-19  Mark Page <mpagenva@aol.com>

	* nsd/tclinit.c: suppress byte-compile for interp init scripts
        * nsd/tclthread.c: fix fmr.

2003-05-16  Zoran Vasiljevic <zoran@archiware.com>

	* nsdb/dbinit.c: fixed hash table initialization in IncrCount
	to TCL_ONE_WORD_KEYS instead of TCL_STRING_KEYS. Credits to
	Jean-Fabrice RABAUTE for the bug report.

2003-05-14  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/tclthread.c: fixed NsTclCondObjCmd to be compatible
	to the 3.x pendant in way it threats the optional timeout
	argument. The 3.x reverted to indefinite (i.e. non-timewait) 
	condvar waits when the optional "timeout" argument was given
        as zero.
	The 4.x version just exited with NS_TIMEOUT (= 0) in such 
 	cases breaking Tcl scripts written for 3.x.
        The corrective measure is to check the passed timeout value
	and if == 0, revert to non-timewait condition waits as the
	3.x does (did).
	
2003-05-13  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_6
	
2003-05-12  Mark Page  <mpagenva@aol.com>

	* nsd/urlencode.c : (bug fix) urlencode was passing through too
        many characters unencoded.  In particular, the '+' was getting
        passed through, which causes unsymmetric encode/decode since
        '+' in encoded string translates to ' '(space).

2003-04-25  Mark Page  <mpagenva@aol.com>

	* nsd/tclvar.c (NsTclNsvArrayObjCmd): (bug fix) nsv_array exists
	must return true if an nsv exists, regardless of the number of
	array elements in the nsv.

2003-04-24  Mark Page  <mpagenva@aol.com>

	* nsd/queue.c (ConnRun): Ensure that a Internal Error status is
	returned to the client if an error status is returned from a
	pre-auth filter.  Previously, the connection was simply closed,
	causing difficult to diagnose problems to the client.  Also
	allow traces to run in this situation, so that access logging can
	occur.

2003-04-23  Mark Page  <mpagenva@aol.com>

	* nsd/log.c (NsTclLogObjCmd): (bug fix) Tweeked previous fix to
	suppress trailing space on output.

2003-04-22  Nathan Folkman <shmooved@aol.com>

        * nsd/log.c: (bug fix) Fixed bug causing first two string
        args of "ns_log" to be improperly concatendated.

2003-04-16  Mark Page  <mpagenva@aol.com>

	* nsd/modload.c (NsLoadModules): (bug) Failed parsing the explicit
	initialization specification properly.

2003-04-10  Mark Page  <mpagenva@aol.com>

	* TAG aolserver_v4_r0_beta_5
	
2003-04-07  Mark Page  <mpagenva@aol.com>

	* nsd/tclthread.c (NsTclThread): ensure that the server has
	completed it's initializtion prior to initiating TclEval.
	* nsd/nsmain.c (Ns_WaitForStartup): add dirty-read of the
	conf.started flag.

2003-04-04  Mark Page  <mpagenva@aol.com>

	* nsd/tclinit.c:
	* nsd/tclcmds.c: Moved interp tracing functionality into ns_ictl
	api as one of it's subfunctions, removing the
	ns_register_interptrace api previously created.

2003-04-03  Mark Page  <mpagenva@aol.com>

	* nsd/tclinit.c:
	* nsd/tclcmds.c: Provide tcl api that exposes Ns_TclInitInterps
	and Ns_TclRegisterTrace.  ns_register_interptrace.

2003-03-30  Scott S. Goodwin  <scott@scottg.net>

	* include/ns.h:
          nsd/driver.c:
          nssock/nssock.c:
          nsssl/nsssl.c: Modified Ns_DriverInit. Instead of passing all args
          as parameters to Ns_DriverInit, a comm module must now create an
          Ns_DriverInitData structure and populate it with appropriate values
          (see include/ns.h) and pass that in the call to Ns_DriverInit. The
          Ns_DriverInitData structure is versioned so that we can extend it
          later without affecting other modules.

2003-03-28  Mark Page  <mpagenva@aol.com>

	* nsd/tclhttp.c: (bug) Fix uninitialized hdrs var, was causing segfault.

2003-03-21  Mark Page  <mpagenva@aol.com>

        * TAG aolserver_v4_r0_beta_4

2003-03-19  Mark Page  <mpagenva@aol.com>

        * nsd/tclhttp.c: Added method argument to ns_http queue api to
        allow sending POSTs as well as GETs.

2003-03-19  Mark Page  <mpagenva@aol.com>

        * nsext/nsext.c: Change back to using ns_socketpair for local
        proxies, to retain PEEK functionality.

2003-03-19  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/modload.c: added fallback for loading regular
	shared libraries in addition to bundles on Darwin.

	* include/tcl.h: added set of version macros
	* nsd/config.c: added Ns_GetVersion API call.

2003-03-10  Scott S. Goodwin  <scott@scottg.net>

	* nscgi/nscgi.c: (bug) SERVER_NAME is now set correctly.

2003-03-10  Mark Page  <mpagenva@aol.com>

	* nsd/sched.c: (bug) Fix problem with shutting down event threads
	(these service detachted thread processing) on a server shutdown.

2003-03-07  Nathan Folkman <shmooved@aol.com>

        * TAG aolserver_v4_r0_beta_3

2003-03-07  Zoran Vasiljevic <zoran@archiware.com>

	* include/ns.h:
	* nscgi/nscgi.c:
	* nscp/nscp.c:
	* nsd/adpeval.c:
	* nsd/adpparse.c:
	* nsd/binder.c:
	* nsd/config.c:
	* nsd/conn.c:
	* nsd/connio.c:
	* nsd/dns.c:
	* nsd/driver.c:
	* nsd/dstring.c:
	* nsd/encoding.c:
	* nsd/fastpath.c:
	* nsd/index.c:
	* nsd/info.c:
	* nsd/lisp.c:
	* nsd/listen.c:
	* nsd/log.c:
	* nsd/modload.c:
	* nsd/nsmain.c:
	* nsd/pidfile.c:
	* nsd/queue.c:
	* nsd/request.c:
	* nsd/rollfile.c:
	* nsd/sched.c:
	* nsd/sockcallback.c:
	* nsd/tclatclose.c:
	* nsd/tclfile.c:
	* nsd/tclhttp.c:
	* nsd/tclimg.c:
	* nsd/tclinit.c:
	* nsd/tcljob.c:
	* nsd/tclmisc.c:
	* nsd/tclshare.c:
	* nsd/tclsock.c:
	* nsd/tclvar.c:
	* nsd/tclxkeylist.c:
	* nsd/urlencode.c:
	* nsd/urlspace.c:
	* nsdb/dbinit.c:
	* nsdb/dbtcl.c:
	* nsext/nsext.c:
	* nslog/nslog.c:
	* nspd/log.c:
	* nspd/main.c:
	* nsperm/nsperm.c:
	* nsthread/mutex.c:
	* nsthread/nsthreadtest.c:
	* nsthread/pthread.c: 
	  o. removed unused variables
	  o. fixed warnings about non-initialized vars
	  o. CONST-ified according to Tcl 8.4+ rules
	
	* bin/init.tcl: _ns_getscript forces import of 
  	  namespaced commands

	* tcl/init.tcl: sets auto_path to start with 
	  our private library first
	
	* include/Makefile.global.in: allows for building 
	  with Solaris 2.6 and later
 
2003-03-06  Mark Page  <mpagenva@aol.com>

	* nsd/adpeval.c: Change defn of objs field of InterpPage to size
	1, since some compilers don't like 0 sized arrays.

	* nsd/urlencode.c: 
	* nsd/queue.c:
	* nsd/server.c:
	* nsd/urlencode.c:
	* nsd/encoding.c:
	* nsd/nsd.h:
	* nsd/form.c:
	* nsd/conn.c:
	* include/ns.h:
	* tcl/form.tcl:
	* tcl/charsets.tcl(new): Added Tcl I18N support functions from
	OACS, with some changes to work within 4.0.

2003-03-05  Zoran Vasiljevic <zoran@archiware.com>

	* nsd/init.tcl: added handling of commands imported from
	  other namespaces in _ns_getscript procedure.

2003-03-05  Mark Page  <mpagenva@aol.com>

	* nsd/adpeval.c: (fix) Fixed handling of Tcl errors from script.

2003-03-05  Mark Page  <mpagenva@aol.com>

	* nsd/adpeval.c:
        * nsd/adpcmds.c:
	* nsd/nsd.h: (patch) Added optional switches to ns_adp_parse;
	-cwd <path>, -savedresult <varname>
	-savedresult supports usages which require the adp script's result
	separate from the output buffer (which is the func result)
	-cwd supports prespecifying the initial cwd for which the script
	will be executed.

2003-03-03 Nathan Folkman <shmooved@aol.com>

        * nscgi/nscgi.c: (bug fix) Applied patch to set SCRIPT_NAME 
        which is passed as an environment variable to the CGI script.
        SF bug 230479.

2003-02-25  Nathan Folkman <shmooved@aol.com>

        * nsd/init.tcl: (patch) Added logging of errorInfo
        and errorCode globals to _ns_sourcefile command.
        SF patch 690025.

        * sample-config.tcl:
        * tcl/fastpath.c: (bug fix) Added fast path configuration
        example. Fixed bug that was adding an extra slash to 
        directory listings in _ns_dirlist. SF bug 682077.

        * nsd/tclimg.c: (bug fix) Fixed ns_jpegsize command for
        images which contained a DHT. Removed AppendDims command
        which has been replaced with AppendObjDims. SF bug 685055.

2003-02-07  Elizabeth Thomas <eathomas93@aol.com>

        * TAG aolserver_v4_r0_beta_2

        * tcl/sendmail.tcl: (bug fix) SF bugs 669217/669844
        Fix handling of addressees so we don't lose friendly address name
    
        * configure: fix additional defaults from cc to gcc

2003-02-06  Mark Page <mpagenva@aol.com>

        * nsd/return.c: (bug fix) SF bug 674033.
        (bug fix) Correct the status code for BadRequest returns.

2003-02-06  Jamie Rasmussen <jrasmuss@mle.ie>

        * nsthread/winthread.c: (bug fix) SF bug 675033.
        (bug fix) Fixed crash on second DLL_THREAD_DETACH.

2003-02-05  Elizabeth Thomas <eathomas93@aol.com>

        * nsext.c: Fix LocalProxy function to call Ns_CloseOnExec
        after the file descriptors have been opened instead of before

2003-02-04  Jamie Rasmussen <jrasmuss@mle.ie>

        * include/nsthread.h:
        * include/ns.h:
        * nscgi/nscgi.c:
        * nscp/nscp.c:
        * nsd/adpeval.c:
        * nsd/driver.c:
        * nsd/encoding.c:
        * nsd/exec.c:
        * nsd/fastpath.c:
        * nsd/fd.c:
        * nsd/info.c:
        * nsd/init.c:
        * nsd/listen.c:
        * nsd/modload.c:
        * nsd/nsd.h:
        * nsd/nsmain.c:
        * nsd/pathname.c:
        * nsd/request.c:
        * nsd/server.c:
        * nsd/sock.c:
        * nsd/sockcallback.c:
        * nsd/tclenv.c:
        * nsd/tclfile.c:
        * nsd/tclhttp.c:
        * nsd/tclimg.c:
        * nsd/tclsock.c:
        * nsd/tclxkeylist.c:
        * nsd/urlencode.c:
        * nsd/urlopen.c:
        * nsd/getopt.c:
        * nsd/getopt.h:
        * nsd/nswin32.c:
        * nssock/nssock.c:
        * win32: Added Win32 support and build files

2003-02-04  Nathan Folkman <shmooved@aol.com>

        * nsd/tclmisc.c: (bug fix) Fixed arg checking bug in
        NsTclStrftimeObjCmd (ns_fmttime) API.

2003-02-03  Jamie Rasmussen <jrasmuss@mle.ie>

        * tcl/sendmail.tcl: (bug fix) SF bug 632265.
        * Fixed minor spelling errors in comments.

2003-02-01  Nathan Folkman <shmooved@aol.com>

        * tcl/stats.tcl: Consolidated web based stats interface into
        a single Tcl file.
        * sample-config.tcl: Added web stats configuration.

2003-01-31  Mark Page  <mpagenva@aol.com>

	* nsd/conn.c: 
	* nsd/connio.c:
	* nsd/encoding.c:
	* nsd/form.c:
	* nsd/nsconf.c:
	* nsd/nsd.h:
	* nsd/queue.c:
	* nsd/return.c:
	* nsd/tclcmds.c:
	* nsd/tclresp.c:
	* nsd/urlencode.c:
	* include/ns.h: added in I18N capabilities derived from the OACS
	I18N design.  This set of changes is just those which are
	supported within the nsd C-code.
	* sample-config.tcl: Add text for I18N specific config.

2003-01-28  Nathan Folkman <shmooved@aol.com>

        * nsd/server.c:
        * tcl/fastpath.tcl: (bug fix) Tcl code was updated to reflect a
        a change made earlier to server.c, in which all fast path related
        configuration was moved from ns/server/<server> to
        ns/server/<server>/fastpath. This change will require you to
        update your configuration file to reflect the new configuration
        path for any fast path options.
        *** INCOMPATIBILITY ***

2003-01-28  Nathan Folkman <shmooved@aol.com>

        * nsd/init.tcl: (bug fix) Updated ns_eval command to mark Tcl interp for
        deletion in the case of a TCL_ERROR only. Updated ns_eval to properly
        handle an arbitrarly long number of args. SF bug 675506.

2003-01-24  Elizabeth Thomas <eathomas93@aol.com>

	* include/Makefile.global.in:
        * README: Added $(PURIFY) variable back from 3.4 to facilitate 
        easy purify compile. 

        * configure: Made gcc the default value for $CC instead of cc.

2003-01-23  Elizabeth Thomas <eathomas93@aol.com>

	* Tagged first 4.0 beta: aolserver_v4_r0_beta_1

2003-01-19  Nathan Folkman <shmooved@aol.com>

        * nscp/nscp.c: Cleaned up log messages to be more consistent 
        with other server messages. Moved user name from thread name into
        log notice. Control port logging now disabled by default. Added
        more detailed configuration instructions to sample-config.tcl.

2003-01-18  Jim Davidson <jgdavidson@aol.com>

	* nsd/auth.c:
	* nsd/conn.c:
	* nsd/form.c:
	* nsd/httptime.c:
	* nsd/info.c:
	* nsd/log.c:
	* nsd/mimetypes.c:
	* nsd/nsconf.c:
	* nsd/nsd.h:
	* nsd/nsmain.c:
	* nsd/pathname.c:
	* nsd/random.c:
	* nsd/tclcmds.c:
	* nsd/tclfile.c:
	* nsd/tclhttp.c:
	* nsd/tclimg.c:
	* nsd/tclinit.c:
	* nsd/tclmisc.c:
	* nsd/tclrequest.c:
	* nsd/tclresp.c:
	* nsd/tclset.c:
	* nsd/tclsock.c:
	* nsd/tclthread.c:
	* nsd/urlencode.c:
	* nsd/urlopen.c:  Removed old string commands.

	* nsd/conn.c:
	* nsd/connio.c:
	* nsd/driver.c:
	* nsd/init.c:
	* nsd/nsd.h:
	* nsd/queue.c:
	* nsd/return.c:
	* nsd/server.c:
	* nsd/tclinit.c:  Moved Host header mapping code from
	queue.c to driver.c to catch cases of unmapped Host's.
	Also, updated the Conn and Sock structures to maintain the
	servPtr and location correctly Host header based connections.

	* nsthread/Makefile:
	* nsthread/cond.c (removed):
	* nsthread/error.c:
	* nsthread/memory.c:
	* nsthread/mutex.c:
	* nsthread/nsthreadtest.c:
	* nsthread/pthread.c (added):
	* nsthread/reentrant.c:
	* nsthread/thread.c:
	* nsthread/thread.h:
	* nsthread/time.c:
	* nsthread/tls.c:
	* nsthread/winthread.c (added):
	* include/nsthread.h:  Brought forward nsthread library
	from 3.5 which includes support for Win32.


2003-01-18  Zoran Vasiljevic <zoran@archiware.com>
	
	* nsd/init.tcl: Summary of changes:
	  o. added _ns_getpackages to enable "package require".
	  o. fixed various issues in ns_getscript proc related to
	     loading Tcl modules which define namespaced versions
	     of standard Tcl commands.
	  o. fixed ns_eval to return value/error and made compatible
	     with standard Tcl "eval" and AOLserver "ns_eval" from 3.x
	  o. made the entire file little bit more readable.

2003-01-17  Mark Page  <mpagenva@aol.com>

	* nsd/driver.c: Change to SockRead; if request has a
	content-length, null-terminate the content at the specified
	length.  This fixes a problem when some browsers add extra CRLF
	characters beyond the specified content-length on a POST (see this
	by using IE to POST data).

2003-01-16  Elizabeth Thomas <eathomas93@aol.com>

        * nsd/tclmisc.c: Fix WordEndsInSemi so that ns_striphtml correctly
        * handles ampersands that are not followed by a space or semicolon

2002-11-06  Jeremy Collins <jcollins@phpsource.net>

        * nsd/adpparse.c: Changed ParseAtts to make it compatible with
        how parsing works in 3.x.

        * nsd/init.tcl: Fixed namespace bug.

2002-11-05  Jeremy Collins <jcollins@phpsource.net>

        * nsd/adpparse.c: Fixed a bug in Parse.  It was not parsing
        registered tags inside of html tags (ex. <td bgcolor='<tag n='v'>'> )

        * nsd/tclset.c: Fixed a bug with ns_set tcl commands.  
        ns_set idelkey|delkey would not actually delete the key.

2002-11-02  Jim Davidson <jgdavidson@aol.com>

	* nsd/fastpath.c:  Fixed bug with non-server specific cache names.

2002-11-01  Jeremy Collins <jcollins@phpsource.net>

        * nsd/adpparse.c: Fixed a small bug in ParseAtts.  It failed
        to properly parse attribute values with spaces in them.

2002-10-29  Jim Davidson <jgdavidson@aol.com>

	* sample-config.tcl:  Updated with examples for connection
	thread pools and Host header virtual servers.

	* Makefile:  Uses /bin/sh to invoke install-doc.

	* doc/install-doc:  Uses /bin/sh to invoke mkLinks.

	* nsd/form.c:
	* nsd/conn.c:
	* tcl/form.tcl:  Changed "ns_conn files" command to just
	return names of file upload widgets, moving access to other
	meta data to new fileoffset, filelength, and fileheaders
	subcommands. Also, removed the ns_conn string command
	instead of updating.

	* nsd/nsd.h:
	* nsd/driver.c:
	* nsd/nsmain.c:
	* nsd/server.c:
	* nsd/queue.c:  Implemented multiple named thread pools
	for virtual servers and Host header based virtual server
	selection.  See sample-config.tcl for config example.

	* nsd/info.c: Fixed crash bug with NULL server.

	* nsd/tclcmds.c: Removed NsTclConnCmd and NsTclServerCmd
	string commands.


2002-10-14  Jim Davidson <jgdavidson@aol.com>

	* doc/install-doc (new):  New script to install and cross
	link the man pages.

	* Makefile:
	* include/Makefile.module:  Added .PHONY targets and man
	page install target.

	* nsd/conn.c:  Made "ns_conn copy" use Tcl_Write instead
	of Tcl_WriteChars to fix binary file upload bug.

	* nsd/form.c:  Fixed bug where Ns_ConnGetQuery (i.e.,
	ns_conn form) could not handle binary data in multpart file
	uploads.  Also, "ns_conn files" now returns file type.
	
	* nsd/log.c:  Thread ids are now formatted as unsigned
	long.

	* include/ns.h:
	* nsd/config.c:
	* nsd/tclinit.c:
	* nsd/tclcmd.c:
	* nsd/tclsock.c:
	* nsd/main.c:  Added support for libnsd.so to be loaded
	into a standard (thread enabled) tclsh or linked into a
	custom tclsh.  Calling Ns_TclInit from a custom tclsh or
	loading libnsd.so via the load command will add many
	non-server AOLserver commands (e.g., adds ns_set but not
	ns_adp_puts).

	* nsd/server.c:
	* nsd/tcljob.c:  Changed ns_job command to create and queue
	jobs to named queues instead of per-server queues.

	* nsd/tclthread.c:  Added a special Tcl address object type
	to speed access to the object id's.

	* nsd/sched.c:  Threaded events now use a thread pool
	instead of create/delete each time.

	* tcl/form.tcl:  Fixed bug accessing uploaded binary files
	with the ns_getform proc and added ns_getformfile proc to
	address the ".tmpfile" security issue.


2002-09-28  Jim Davidson <jgdavidson@aol.com>

	* nsd/adpparse.c:
	* nsd/auth.c:
	* nsd/conn.c:
	* nsd/connio.c:
	* nsd/driver.c:
	* nsd/dstring.c:
	* nsd/filter.c:
	* nsd/init.c:
	* nsd/log.c:
	* nsd/main.c:
	* nsd/modload.c:
	* nsd/nsd.h:
	* nsd/nsmain.c:
	* nsd/queue.c:
	* nsd/return.c:
	* nsd/server.c:
	* nsd/tclenv.c:
	* nsd/tclinit.c:
	* nsd/tclthread.c:
	* include/ns.h: Added missing AOLserver 3.x API's including
	static module support, Ns_TclRegisterAt traces, connection
	I/O functions, loadable comm driver stubs, and more.

	* configure:
	* configure.in:
	* nsd/exec.c:  Removed weird USE_PROCTHREAD code.

	* nsd/init.tcl:  Uses "ns_ictl modules" for module list.

	* nscgi/nscgi.c:  Uses Ns_CopyEnviron, renamed from
	Ns_GetEnvironment.

	* Makefile:  Fixed install bug for install-sh.
	
	* README:  Updated to match AOLserver 3.5.  Various outdated
	docs removed.


2002-09-10  Jim Davidson <jgdavidson@aol.com>

	* Makefile:
	* INSTALL (new):
	* aclocal.m4 (new):
	* configure (new):
	* configure.in (new):
	* include/Makefile.global (removed):
	* include/Mkaefile.global.in (new):
	* include/Makefile.module:  New autoconf-based configuration
	and build.

	* nsd/log.c:
	* nsd/tclenv.c:  Updated to used new autoconf-based compile
	info.


2002-08-24  Jim Davidson <jgdavidson@aol.com>

	* nsd/filter.c:
	* nsd/server.c:
	* nsd/tclatclose.c:
	* nsd/tclvar.c:
	* nsd/tclinit.c:
	* nsd/tcljob.c:
	* nsd/nsd.h:  Moved private struct definitions out of nsd.h
	back to files which depend on them, e.g., struct Filter.

	* nsd/tclatclose.c:
	* nsd/tclinit.c:  Moved Ns_TclRegisterDeferred to tclinit.c.

	* nsd/adpeval.c:
	* nsd/tclsock.c:
	* nsd/tclinitc:  Eliminated NsTclEval in favor of Tcl_EvalEx.

	* nsd/log.c:
	* nsd/nsconf.h:
	* nsd/nsconf.c:  Removed complicated and dubious log
	buffering option.  The new ns_logctl feature can be used
	to batch noisy requests.

	* nsd/tclinit.c:
	* nsd/tclcmds.c:
	* nsd/init.tcl:  Added new ns_init command to replace the
	nsv-based namespace copy/update mechanism.  The init.tcl
	is now called only at startup.

	* conn.c:
	* driver.c:
	* queue.c:
	* nsd.h:  Connection times and timeouts now maintained with
	Ns_Time-based microsecond resolution.

2002-07-14  Jim Davidson <jgdavidson@aol.com>

	* nsd/log.c:
	* nsd/tclcmds.c:  Added the ns_logctl command with options
	to hold, release, flush, etc. the log messages in a thread.

	* nsd/adpcmds.c:
	* nsd/urlopen.c:  Switched to more object-correct
	Tcl_ObjSetVar2.

2002-07-08  Jim Davidson <jgdavidson@aol.com>

	* nsd/tclthread.c:  Cleaned up the object-based commands
	by collecting common argument and new object allocation
	code into single GetArgs function.

2002-07-07  Jim Davidson <jgdavidson@aol.com>

	* nsd/tclvar.c:  Removed string commands because it was
	messy maintaining both.

	* nsd/info.c:
	* nsd/queue.c:
	* nsd/tclcmds.c:
	* nsd/tclset.c:  Added object commands.

	* nsd/tclobj.c:
	* nsd/tclmisc.c:  Updated Ns_Time type code to handle simple
	single-integer times without microsecond resolution.

	* include/ns.h:
	* include/Makefile.global:
	* Makefile:  Updated for AOLserver beta4 release to coincide
	with Tcl beta1 release.

	Otherwise, minor edits to new object commands in several
	places.
	
2002-07-05  Jim Davidson <jgdavidson@aol.com>

	* nsd/nsd.h:
	* nsd/adpcmds.c:
	* nsd/adpeval.c:
	* nsd/adprequest.c:
	* nsd/tclcmds.c:  Updated remaining ADP commands to be
	object-based.  Because the NsInterp->adp struct now uses
	Tcl_Obj's for call frame args, the string commands were
	just dumped.

2002-06-25  Scott S. Goodwin <scott@scottg.net>

	* nsd/tclvar.c:
	* nsd/tclcmds.c: Reimplemented nsv commands as object commands.

2002-06-19  Jim Davidson <jgdavidson@aol.com>

	* include/ns.h:
	* nsd/tclinit.c:  Added new Ns_TclCreateInterp() which
	creates and initializes interps for server and non-server
	interps (e.g., the config interp).  Interps are now
	initialized with a call to Tcl_Init() which enables the
	standard Tcl library procedures (e.g., unknown, http::,
	etc.).

	* nsd/tclthread.c:
	* nsd/tclcmds.c:  Thread and cache related commands no
	longer require a server, exposing them in any interp created
	with Ns_TclCreateInterp.
	
	* nsd/server.c:  NsGetServer handles NULL server.

	In general, the changes above are steps towards making the
	AOLserver API's more useful outside the context of a server.
	The idea is to enable use of libnsd for other applications,
	e.g., shells interps.

2002-06-12  Jeremy Collins <jeremy.collins@phpsource.net>

	* nsd/conn.c:
	* nsd/tclcmds.c: Reimplemented "ns_conn" as an obj based
	command.  In the process I also modified NsTclConnObjCmd to use
	Tcl_GetIndexFromObj.  This should improve performance as well as
	the readability of the code.

	* nsd/auth.c:
	* nsd/form.c:
	* nsd/httptime.c:
	* nsd/log.c:
	* nsd/mimetypes.c:
	* nsd/nsmain.c:
	* nsd/pathname.c:
	* nsd/random.c:
	* nsd/tclatclose.c:
	* nsd/tclfile.c:
	* nsd/tclhttp.c:
	* nsd/tclimg.c:
	* nsd/tclinit.c:
	* nsd/tclmisc.c:
	* nsd/tclrequest.c:
	* nsd/tclresp.c:
	* nsd/tclsock.c:
	* nsd/tclthread.c:
	* nsd/urlencode.c:
	* nsd/urlopen.c: Cleaned up the way we were setting the result
	on tcl errors.

2002-06-12  Jim Davidson <jgdavidson@aol.com>
	
	* include/nsthread.h:
	* nsthread/mutex.c:
	* nsthread/thread.c:
	* nsd/info.c:  Rename Ns_MutexEnum and Ns_ThreadEnum to
	Ns_MutexList and Ns_ThreadList to not conflict with pre-4.0
	definitions of removed functions.

	* nsthread/Makefile
	* nsthread/nshtreadtest.c (new file):  Added simple program
	to test thread interface.

	* nsthread/thread.h:
	* nsthread/cslock.c:
	* nsthread/rwlock.c:  Added new NsMutexInitNext function
	to consistantly name mutexes in internal objects.

	* nsthread/sema.c:  Restored AOLserver 3.x implementation
	using Ns_Mutex and Ns_Cond objects.  The API's in <semaphore.h>
	were not implemented on OS/X.

2002-06-10  Jim Davidson <jgdavidson@aol.com>

	* include/Makefile.global:
	* include/Makefile.module:  Added support for dynamic
	library init procs set via the LIBINIT make variable.

	* Makefile: 
	* nsthread/compat.c:
	* nsthread/cond.c:
	* nsthread/cslock.c
	* nsthread/error.c:
	* nsthread/fork.c:
	* nsthread/master.c:
	* nsthread/memory.c:
	* nsthread/mutex.c:
	* nsthread/osxcompat.c:
	* nsthread/osxcompat.h:
	* nsthread/reentrant.c:
	* nsthread/rwlock.c:
	* nsthread/sema.c:
	* nsthread/signal.c:
	* nsthread/thread.c:
	* nsthread/thread.h (new file):
	* nsthread/time.c:
	* nsthread/tls.c:  Moved from nsd as separate nsthread
	library.

	* include/ns.h:
	* include/nsthread.h:  Include of tcl.h moved to nsthread.h
	from ns.h.

	* nsd/Makefile
	* nsd/init.c (new file):
	* nsd/binder.c:
	* nsd/cache.c:
	* nsd/config.c:
	* nsd/encoding.c:
	* nsd/exec.c:
	* nsd/info.c:
	* nsd/listen.c:
	* nsd/log.c:
	* nsd/mimetypes.c:
	* nsd/modload.c:
	* nsd/nsd.h:
	* nsd/nsmain.c:
	* nsd/nsconf.c:
	* nsd/proc.c:
	* nsd/sched.c:
	* nsd/server.c:
	* nsd/tclinit.c:
	* nsd/urlspace.c:  Various runtime initializations collected
	into dynamic library load time init via NsdInit in init.c.

2002-06-08  Jim Davidson <jgdavidson@aol.com>

	* include/Makefile.global
	* include/Makefile.module:  Support for building programs
	along with dynamic libraries and modules.  Also, fixed bug
	setting -install_name on OS/X.

	* nsd/Makefile:  Use of updated Makefile.module and include
	osxcompat.o on OS/X.

	* nsd/nsd.h:
	* nsd/osxcompat.h:
	* nsd/osxcompat.c:  Compat functions moved from ../nsosx.

	* nsosx/README (removed):
	* nsosx/Makefile (removed):
	* nsosx/nsosx.c (removed):  Tcl no longer requires any
	compat functions, remainder moved into nsd.

	Otherwise, minor tweaks throughout to silence compiler
	warnings.

2002-06-05  Jim Davidson <jgdavidson@aol.com>

	* Makefile:
	* include/Makefile.global:  Added tclmemdbg flag to compile
	Tcl and AOLserver with TCL_MEM_DEBUG option.

	* nsd/unix.o:
	* nsosx/README (new file):
	* nsosx/Makefile (new file):
	* nsosx/nsosx.o (new file):  Hacks for Apple OS/X removed
	from nsd/unix.o and moved to nsosx.o as a Tcl compat object.
	See README for instructions.

	* nsd/nsd.h:
	* nsd/server.c:
	* nsd/adpparse.c:
	* nsd/adpcmds.c:
	* nsd/adpeval.c:  Added support for new ns_adp_safeeval
	and ns_adp_registerproc commands. Also, registered tags
	can now be modified after startup.

	* include/Makefile.module:  Updated to allow building of
	dynamic library of public routines to go with dynamic
	module, e.g., libnsdb.so with nsdb.so.

	* nsext/Makefile:
	* nspd/Makefile:
	* nspd/msg.c (removed):
	* nsext/msg.c (moved from nspd):  Moved Ns_Ext API from
	libnspd.a static library to libnsext.so dynamic library as
	it's used by both nsext.so and proxy drivers.

	* nsdb/Makefile:
	* nsdb/nsext.c (new file):  Moved public API for nsdb out
	of nsdb.so module and into libnsdb.so dynamic library.

2002-05-15  Jim Davidson <jgdavidson@aol.com>

	* Makefile:
	* include/Makefile.global:
	* tcl8.3.4 (removed):  As of Tcl version 8.4., no modifications
	to the Tcl sources are required for AOLserver.  Therefore,
	the hacked 8.3.4 sources have been removed.  Going forward
	you'll need to checkout the Tcl source from Sourceforge
	into the directory specified in include/Makefile.global
	(currently ../tcl8.4).  The top level Makefile includes
	the "tcl-checkout" and "tcl-update" targets which should
	help.
	
	* include/ns.h:
	* nsd/server.c:
	* nsd/nsd.h:
	* nsd/tclcmds.c:
	* nsd/tclinit.c:
	* nsd/init.tcl:
	* nsd/dbdrv.c (removed):
	* nsd/dbinit.c (removed):
	* nsd/dbtcl.c (removed):
	* nsd/dbutil.c (removed):
	* nsdb/dbinit.c (new):
	* nsdb/dbdrv.c (new):
	* nsdb/dbtcl.c (new):
	* nsdb/dbutil.c (new):
	* include/nsdb.h (new):  Moved the NsDb interface from core
	to new nsdb module.  Simply loading nsdb.so should work as
	before.  Goal is to enable full replacement of NsDb in the
	future.

	* nsd/cache.c:
	* nsd/callbacks.c:
	* nsd/listen.c:
	* nsd/nsconf.c:
	* nsd/op.c:
	* nsd/sched.c:
	* nsd/server.c:
	* nsd/sockcallback.c:
	* nsd/urlspace.c:
	* nsext/nsext.c:
	* nslog/nslog.c:
	* nslog/nslog.c:  Simple mutex name updates.

	* nscgi/nscgi.c:  Minor bug fixes

	* nsd/adpeval.c:  Fixed read of freed data.

	* nsd/tclinit.c:  Fixed crash bug of null interp delete.

	* nsd/exec.c:
	* include/Makefile.global:  Support for process manager
	thread enabled with -DUSE_PROCTHREAD to route all process
	create/wait through a single thread for Linux threads.

2002-02-24  Jim Davidson <jgdavidson@aol.com>

	* nsd/nsd.h
	* nsd/unix.c:
	* tcl8.3.4/unix/tclLoadDyld.c: Hacks for routines missing
	from OS/X. The implementation of sigwait() is not strictly
	correct but appears good enough for AOLserver's use.

	* Makefile:
	* nsd/Makefile:
	* nsmain/Makefile:
	* include/Makefile.global:
	* include/Makefile.module:
	* include/Makefile.library (removed): Updates for linking
	modules against the nsd shared library and for library
	filenames which don't end in .so.

	* nsext/Makefile
	* nspd/Makefile: Moved proxy message code from nsext to
	nspd, now a static library.

	* nsd/main.c:
	* nsd/init.c:
	* nsd/Makefile:
	* nsmain/*:
	* sample-config.tcl:
	* tcl2ini.tcl:
	* ini2tcl.tcl:
	* Makefile: Moved build and install of nsd and init.tcl
	into nsd directory and install of sample config to top
	level Makefile.  Added tcl2ini.tcl and ini2tcl.tcl config
	file utilities.

2002-02-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* nsmain/init.tcl:
	* nsmain/sample-config.tcl:
	* nsssl/keygen.tcl:
	* tcl/debug.tcl:
	* tcl/fastpath.tcl:
	* tcl/file.tcl:
	* tcl/form.tcl:
	* tcl/http.tcl:
	* tcl/nsdb.tcl:
	* tcl/sendmail.tcl:
	* tcl/util.tcl: code cleanup to brace exprs and fix indentation

2001-12-05  Jim Davidson <jgdavidson@aol.com>

	* nsd/tclthread:  Tcl threads now return their string result
	via ns_thread wait.

2001-12-20  Scott S. Goodwin  <scott@scottg.net>

	* include/Makefile.library: Changed RFLAG to RPATH, and took out
	$(AOLSERVER)/lib:
	
	  $(LDSO) -o $(LIB) $(OBJS) $(LIBS) $(RFLAG) $(AOLSERVER)/lib

	now reads:
	
	  $(LDSO) -o $(LIB) $(OBJS) $(LIBS) $(RPATH)

	which is what I think was intended. Still have the problem
	that $(AOLSERVER)/lib must already exist.

2001-11-05  Jim Davidson <jgdavidson@aol.com>

	* Removed support for Win32, removing both the build/test
	environment and updating the code to be standard Unix style.
	Among other style changes such as changing SOCKET's to
	simple Unix style int's, the short lived Ns_Buf structure
	was also eliminated in favor of the Unix standard struct
	iovec.

	* Removed support for older non-pthread Unix platforms such
	as HP/10 and SGI native.

	* Updated Tcl to version to Tcl 8.3.4, replacing tclAlloc.c
	with a modified version of what was libnsthread's fast pool
	allocator including support for fast direct Tcl_Obj
	allocation.  Also added a few functions to tclUnixThrd.c
	for thread safety (e.g., readdir_r and localtime_r support)
	and fixed up tcl.m4 for better FreeBSD 4.4 and Solaris
	thread builds.

	* ns_malloc, Ns_ThreadMalloc, and Ns_PoolAlloc all now
	simply call Tcl_Alloc which is always enabled. The previous
	-z (enable) and -p (disable) command line flags are ignored.

	* Integrated remainder of libnsthread, now standard pthreads
	and compatible with Tcl pthread code, into libnsd.so.

	* Updated libnsd.so to use poll() instead of select() where
	possible.

	* Removed the code which would attempt to determine when
	the sock callbacks and scheduler were idle before completing
	startup.  The code was overly complex and not strictly
	correct.

	* Removed the -k and -K shutdown/restart options which was
	not entirely safe.

	* Removed the child-process privleged port Ns_SockListen
	code in nsd/binder.c.  Binding privleged ports (e.g., port
	80) now requires the -b or -B command line methods introduced
	in 3.4, e.g., "nsd -ft nsd.tcl -b myhost:80".  The binder
	code, while clever, was a potential security risk.

	* Cleaned up some lingering sloppy uses of Ns_ConfigGet
	and other older macros.  Old macro and function definitions
	can be disabled by defining NS_NOCOMPAT as is done when
	compiling the core server and modules.

	* Incremented version to 4.0b2.

2001-08-29  Scott S. Goodwin  <scott@scottg.net>

	* https.tcl: made fixes to ns_httppost per Rick Lansky at
	bom.com. He also suggested I allow the Content-type to be
	passed in as a parameter, so I've added that too.

2001-08-27  Scott S. Goodwin  <scott@scottg.net>

	* https.tcl: added ns_httppost, that is called with url,
	rqset, qsset and timeout. The qsset is an ns_set with
	key/values that will be turned into user=scottg&pass=1234,
	for example, and passed as content in the POST.

2001-08-17  Scott S. Goodwin  <scott@scottg.net>

	* tcl/http.tcl: moved rqset to be the last arg passed to
	ns_httpget so it wouldn't break existing code. I should
	have done it that way in the first place.

2001-08-15  Scott S. Goodwin  <scott@scottg.net>

	* tcl/http.tcl: add the rqset param as the second argument to
	ns_httpget, which in turn calls ns_httpsopen and passes the rqset
	to it. The change is for consistency so that you can use cookies
	with ns_httpget as well.

2001-07-16  Scott S. Goodwin  <scott@scottg.net>

	* tcl/http.tcl: you can now do ns_httpopen GET /index.html;
	the script will automatically prepend http://hostname:port/
	to the url.

2001-06-30  Dossy Shiobara  <scott@scottg.net>

	* nsd/conn.c, tests/api/ns_conn.adp: fixed ns_conn
	outputheaders as per bug #433676 submitted by Yon Derek
	(yond).

2001-05-22  Scott S. Goodwin  <scott@scottg.net>

	* nsd/conn.c: changed Ns_ConnDriverContext in 4.x to return
	the actual conn-specific, module-specific context back,
	which is how it works in 3.x. For some reason this API call
	was changed to always return NULL, but nsopenssl and
	potentially other comm drivers need to get their conn-specific
	info back.

2001-04-25  Dossy Shiobara  <dossy@panoptic.com>

	* Implemented [ns_localtime ?tz?] as per "[ #418890 ]
	ns_localtime should accept timezone".

2001-03-15  Dossy Shiobara  <dossy@panoptic.com>

	* include/Makefile.win32 win32/*/Makefile: initial attempts
	at Makefiles suitable for NMAKE for building on Win32

	* include/ns.h: define typedef __int64 INT64 for Win32

2001-03-12  Scott S. Goodwin  <scott@scottg.net>

	* nsmain.c: Segmentation fault when using -g <group> flag:
	line 294 should read Ns_GetGid(garg) instead of Ns_GetGid(optarg).

2001-03-12 Jim Davidson

	Initial checkin of AOLserver 4.0 (beta), now supporting
	vitual servers and (finally) removing supporting for Tcl
	7.6.
	
2001-03-08  Kris Rehberg

	*** AOLserver 3.3 RELEASED ***

2001-03-08 Jim Davidson

	* Added NsTclFinalizeThread() at end of Tcl TLS cleanup to
	finalize Tcl 8.x thread data.  This fix was the last hurdle
	for finalizing nsd8x.

2001-01-31  Kris Rehberg 

	* Makefile (MODULES): nsunix, nsvhr, and nsodbc moved to
	the Module Collection.

2001-01-16  Jim Davidson

	* Cleaned up sloppy use of the nsServer global wherever
	it's used.

2001-01-04  Kris Rehberg 

	* nsd/tclmisc.c: Ticket 13090.  ns_striphtml crashing-bug
	in nsd8x fixed.

2000-12-14  Kris Rehberg 

	* tcl/http.tcl: Corrected typo _ns_ns_http_readable.

	* nsd/dstring.c (Ns_DStringPrintf): Ticket 12765.
	Ns_DStringPrintf uses vsnprintf instead of vsprintf with
	specified buffer size.  Thanks to "??".

	* nsd/return.c (Ns_ConnConstructHeaders): Ticket 12764.
	If-Modified-Since (304) works with keepalive now. Thanks
	to Jim "??".

2000-12-13  Kris Rehberg 

	* include/Makefile.global: Builds with architecture-specific
	optimization options. Auto-detects architecture for most
	platforms.  Auto-select compiler and Purify usage from
	command line, e.g.:
	gmake nativeme=1   (all non-free Unix)
	gmake gccme=1      (some non-free Unix) gmake
	PURIFY=/path/to/purify/executable  (Solaris and Irix only)

	* nssock/Makefile*: now installs The Right Things in The
	Right Places.

	* nsd/Makefile: nsd8x is the default AOLserver now (nsd
	symlinks to nsd8x).

	* nsd/sample-config.tcl: Added some tuning parameters for
	easy reference.

2000-12-12  Kris Rehberg 

	* nsvhr/nsvhr.c (UDSProxy): More type changes.

	* nslog/nslog.c (Ns_ModuleInit): pointer-to-function casted.

	* nscp/nscp.c (GetLine): buf changed to char *; casted
	AcceptProc.
	
2000-12-12  Jim Davidson

	* nssock/sock.cpp: Fixed multiple-load problems, added
	sndbuf, rcvbuf, sendwait, and recvwait options. Added
	configurable backlog via Ns_SockListenEx. Fixed compile
	bugs for ssl. Restructured the socket module to wait in
	server busy situations instead of sending the server busy
	message.  Also, moved the graceful close burden to the
	SockThread from the connection thread.

	* thread/win32.cpp: Moved WinThread allocation to DllMain,
	eliminating GetWinThread function. Also, disabled thread
	cleanup for final thread to avoid any TLS cleanup callbacks
	attempting to invoke code in unloaded libraries like Tcl.
	Removed call to NsInitThread no longer needed. Switched to
	rolling condition broadcast wakeup as in the sproc code.
	More fixes for new Thread context model.
	
	* thread/tls.c: Changed NsLock API's to return 1/0 instead
	of NS_OK/NS_TIMEOUT and more use of Ns_MasterLock to keep
	things simple.

	* thread/thread.c: Changed thread enum to return Ns_Thread,
	not Ns_Thread pointer which didn't make much sense.  Updated
	"ns_info pools" command to reflect change. Fixed bugs with
	Ns_ThreadEnum and pool counters. Update of the Ns_Pool API
	to support more stats gathering available via new Ns_PoolStats
	API. Remove Thread->etime and NsPool API's. Moved sprintf
	of default thread name from NsThreadMain to NsInitThread
	under protection of threads lock. Added comment for
	NsInitThread. More fixes for new Thread context model.
	Updated sproc.cpp code for new Thread management and removed
	the wait for thread startup which shouldn't be needed.

	* thread/test.c: Cleaned up code a bit to quiet compiler.
	Better test for PTHREAD_TEST.  Fixed undefined var bug for
	sproc.  Added some comments, a native pthread test, and a
	recursive stack checker.

	* thread/tcl8x.c: Added Tcl_JoinThread for benefit of
	Tcl8.4.

	* thread/sproc.cpp: Changed NsLock API's to return 1/0
	instead of NS_OK/NS_TIMEOUT and more use of Ns_MasterLock
	to keep things simple. Fixed some comment bugs, update
	thrPtr->tid after fork. Added call the NsInitThread. Updated
	sproc.cpp code for new Thread management and removed the
	wait for thread startup which shouldn't be needed.

	* thread/pthread.cpp: Changed NsLock API's to return 1/0
	instead of NS_OK/NS_TIMEOUT and more use of Ns_MasterLock
	to keep things simple. Fixed bug of not setting the tid
	correctly. Added call the NsInitThread.

	* thread/pool.c: Added Ns_PoolEnum to get at pool stats as
	with mutexes and threads, removing the old Ns_PoolStats
	API's and updating the "ns_info pools" command. Fixed bugs
	with Ns_ThreadEnum and pool counters. Update of the Ns_Pool
	API to support more stats gathering available via new
	Ns_PoolStats API. Removed <mutex.h> for sgi which shouldn't
	have been there. Removed the sbrk() code for now, was
	crashing SGI (probably not thread safe). Use sbrk() on Unix
	instead of malloc to avoid any malloc overhead or contention.
	Reduced the zippy allocator page size to 16k from 64k.

	* thread/pool.c, thread.c, sproc.cpp: Re-structured management
	of the Thread context to better support threads created
	without Ns_ThreadCreate (e.g., Java VM threads).
	
	* thread/mutex.c: Changed NsLock API's to return 1/0 instead
	of NS_OK/NS_TIMEOUT and more use of Ns_MasterLock to keep
	things simple.

	* thread/cs.c, memory.c, mutex.c, pool.c, pthread.cpp,
	reentrant.c, rwlock.c, sema.c, sproc.cpp, tcl8x.c, test.c,
	thread.c, win32.cpp: Restructured the thread interfaces,
	moving the master lock to the platform interface code,
	integrating the zippy allocator with Ns_Pool/Ns_ThreadAlloc
	and use of a new simple direct allocator for all thread
	objects.

	* win32/nsthread/nsthread.dsp: Removed master.c and
	oldpools.c.

	* nsd/unix.c: Made ns_eval command disabled by default to
	avoid using SIGUSR2.

	* nsd/tclthread.c: Changed SETOBJ macro to SetObj function
	which no longer sprintf's directly into interp->result.

	* nsd/tclmisc.c: Added Ns_PoolEnum to get at pool stats as
	with mutexes and threads, removing the old Ns_PoolStats
	API's and updating the "ns_info pools" command. Changed
	thread enum to return Ns_Thread, not Ns_Thread pointer
	which didn't make much sense.  Updated "ns_info pools"
	command to reflect change.  Added more info for "ns_info
	pools".  Added "ns_info pools" command to dump memory pool
	stats.
	
	* nsd/tclinit.c: Added nsconf.quiet and nsconf.startuptimeout.
	Made ns_eval command disabled by default to avoid using
	SIGUSR2.  Added nsConfQuiet flag to quiet down the startup
	messages with the -q flag.

	* nsd/sock.c: Added Ns_SockListenEx.

	* nsd/serv.c: Ensured the conn thread name was set first.
	Added Ns_RegisterAtReady callbacks for indicating server
	no longer busy.

	* nsd/sched.c, nsmain.c, serv.c, sockcallback.c: Added code
	to wait for conn thread, sock callback, and sched idle at
	startup to help alleviate code start problems.

	* nsd/nsmain.c: Shuffled initialization to ensure command
	line args are read before calling any Ns API's, ensuring
	zippy malloc can be set if needed.

	* nsd/nsconf.c: Added nsconf.quiet and nsconf.startuptimeout.
	Made ns_eval command disabled by default to avoid using
	SIGUSR2.

	* nsd/dstring.c: Remove unused vars.  Uses ns_realloc to
	grow strings and maintains dstring stack in the staticSpace
	instead of the *addr pointer for compatibility with Tcl
	dstrings.

	* nsd/callbacks.c: Added Ns_RegisterAtReady callbacks for
	indicating server no longer busy.

	* nsd/binder.c: Added Ns_SockListenEx.

2000-12-12  Kris Rehberg 
	
	* nsvhr/nsvhr.c (VHRProc): Matches hostnames regardless of
	case.

	* nssock: Supports Rainbow CryptoSwift SSL accelerators
	(compile-time option; requires the Swift SDK from
	http://www.rainbow.com/).

	* nsd/nsmain.c (Ns_Main): Changed order of some config
	default initialization.  Config options cleaned up a lot.
	Usage message very less glib.  SUNWspro dumped core on
	usage message due to nsconf.argv0 quigglyness.
	
2000-10-20  Kris Rehberg 

	*** AOLserver 3.2 RELEASED ***

2000-10-20  Jim Davidson

	* win/tclWinSock.c: Fixed deadlock in sockets init code.

	* nsd/nswin32.c: Fixed service install code to allow long
	pathnames with spaces.  Added/use ns_pipe which set's
	close-on-exec like ns_sockpair.
	

2000-10-17  Kris Rehberg 

	* nssock/sock.cpp: extra padding on Server Busy message to
	defeat MSIE friendly error messages.

	* nsd/nsconf.h: All configuration option defaults have been
	moved to nsconf.h as #defines.

	* Makefile (install): Tcl library for nsd8x is now installed
	into $(PREFIX)/lib/tcl8.3.

	* tcl/http.tcl (ns_httpopen): Host:port is now sent to
	remote host if != 80.  Suggested by Jerry Asher.

	* tcl/fastpath.tcl (_ns_dirlist): All kinds of Win32
	pathnames should now be working.  Thanks to Eric Klein.

	* nsd/return.c (Ns_ConnReturnNotice): New options
	"errorminsize", to pad error messages to defeat MSIE friendly
	errors (fix suggested by ArsDigita) and "noticedetail" to
	return more detailed information on notice pages.

	* nslog/nslog.c: suppressquery option added to suppress
	logging of query data.

	* nslog/nslog.c: LogExtendedHEaders option added.  Contributed
	by ArsDigita.


	* nsd/tclfile.c: Input string to mktemp is copied, because
	mktemp edits the string in-place and that's generally a
	bad thing to do with argv's.  Contributed by ArsDigita.

	* nsd/tclnsshare.cpp (ShareTraceProc): Patch to tclnsshare.cpp
	to avoid race conditions if the shared value is a list.
	Contributed by ArsDigita.

	* tcl/http.tcl (ns_httpopen): CRLF now returned in ns_httpopen.
	Contributed by ArsDigita.

	* tcl8.3.2/generic/tclCmdIL.c: Nonsense case of lsorting
	a list with length <= 0 caused a memory leak.  Fixed.
	Contributed by ArsDigita.
	
	* nsd/adpfancy.c: We now use the Arsdigita version of
	adpfancy.  Contributed by ArsDigita.
	
	* nsd/adp.c: Sundry ArsDigita changes.

2000-10-16  Kris Rehberg 

	* tcl/init.tcl:  Initialize errorCode and errorInfo like
	tclsh does.  From ArsDigita.

	* nsd/nsd.h, nsd/tclcmds.c, nsd/tclvar.c: nsv_names Tcl
	command lists names of nsv's in memory.

	* tcl8.3.2: The complete Tcl 8.x distributions are now
	included.  They aren't installed with AOLserver's "gmake
	install", but you can install them manually if you want to
	use them for the i18n encodings and stuff like that.  It
	will install into the "lib/tcl8.3" directory of the binary
	distribution with AOLserver 3.3 and later.

	* nsd/nsmain.c (Ns_Main): Had to move Ns_ThreadSetName
	below the stdin/stdout/stderr reassignment to fix a fd
	problem with running nsd on Irix in "installed" or "daemon"
	mode that would prevent the server from starting up.  Sigh.
	(Ns_Main): Took out little note about -k|-K being deprecated.

2000-10-13  Kris Rehberg 

	* nsd/nsmain.c (Ns_Main): gid of the specified user is set even if
	it's not specified.
	(UsageError): -K and -k give a "deprecated" warning.
	(Ns_Main): -f gives a "deprecated" warning.

	* nsd/binder.c (PreBind): Didn't really tell us if it was
	successful at pre-binding.  Helpful to know if you're
	wondering what happened to that port you wanted to pre-bind.
	(Binder): backlog variables (2) initialized to nsconf.backlog.

	* nssock/sock.cpp, nsd/return.c: Made an attempt at
	standardizing the error codes and error page content.
	
2000-10-13  Jim Davidson
	
	* sproc.cpp: Fixed Wakeup() error message and update child's
	sproc pid after fork.

	* nsd/random.c: Put back log message when generating seeds.

	* nsd/nsconf.c: Fixed memory overwrite bug in stats and
	increased the default buffer value.

	* nsd/keepalive.c: Fixed array overwrite with maxkeep=0
	bug.  Contributed by ArsDigita.
	
	* nsd/tclkeylist.c: A more modern version added that's
	compatible with Tcl 8.3.2 (nsd8x).

	* nsd/stamp.c: Forces the build date reported by AOLserver
	to be absolutely the last possible moment before the link
	step happens, not just the last time nsmain.c was built.

	* nsd/binder.c: New option "-b" to prebind ports as root
	(but not listen on them).  This allows AOLserver to start
	up on MacOS X on ports 80 and 443 like this:  "nsd ..blah..
	-b 10.0.0.1:80".

	* nssock/: Building nsssl is much less of a debacle and
	doesn't rebuild itself three times anymore.

	* various: fork() calls in all kinds of code were changed
	to use ns_fork.  ns_fork now lives in the thread library
	(thread/ directory).

	* tcl8.3.2/generic/tclIO.c: Fixed memory leak that leaks
	around 112 bytes each time a file descriptor is closed.
	Thanks to Rob Mayoff for finding this and proposing a
	solution.

2000-10-09  Kris Rehberg 

	* sample-config.tcl: nsd.tcl is now sample-config.tcl so
	that existing users can look at the new reference configuration.

	* nsd/nsmain.c (Ns_InfoNameOfExecutable): new function just
	returns nsconf.nsd which is determined elsewhere.

	* nscp/nscp.c (Login): Tells you lots of harmless info
	about the machine once you log in.  Also, nscp does not
	run unless configuration is explicitly set

	* nsd/nsmain.c: Some typo or other.

	* General: Files were re-arranged and some were renamed.
	The sample SSL key/cert files are sample-certfile,
	sample-keyfile.  The nsd.tcl is now called sample-config.tcl
	(so that existing installations always have a current
	reference copy of the configuration).  Other minor changes.

	* tests/:  Moved from its hiding place in scripts/test.
	Install them with "gmake install-tests".

	* nsd/tclxkeylist.c, nsd/tclcmds.c, nsd/Makefile: Re-added
	TclX keyl* commands that were in AOLserver 2.x.  These are
	inferior to ns_set which is why they were left out in the
	first place.

2000-10-04  Jim Davidson

	* binder.c: Set close-on-exec on received fd from binder.
	
	* sock.c: Removed cthread errno API's, Mac OS X now has
	thread-safe errno.

	* nsd/nsmain.c, include/Makefile.global, nsd/nsthread.h,
	nspd/main.c, nsunix/nsunix.c, nsvhr/nsvhr.c, thread/Makefile,
	thread/osthread, thread/reentrant.c, thread/signal.c:
	Updates for Mac OS X.  Use MACOSX instead of APPLE; use
	HAVE_BSDSETPGRP, HAVE_CMMSG, use pthreads instead of
	cthreads.
	
	* nssock/sock.c: Removed setting bufsize to uninitialized
	value on ssl.

	* include/ns.h: Removed Ns_CacheTimedGetValue which was an
	odd interface not used anywhere.
	
	* nsd/nsd.h: Update to version 3.11.
	
	* tcl/namespace.tcl: Added namespace export to init script.
	
	* thread/pthread.cpp: Stopped using pthread_once as it
	appears to require a lock.
	
2000-10-04  Kris Rehberg 

	* win32/nsssl/nsssl.dsp: nsssl project for win32.

	* win32/aolserver.dsw: main installation keeps DLL's as
	DLL's now.

	* scripts/nsd.tcl: shared library extension is now
	platform-dependent

	* nssock/ssltcl.c: Changed name of ReadFile adn WriteFile
	to avoid Win32 naming conflicts.
	
2000-09-28  Kris Rehberg 

	* scripts/tests/nstelemetry.adp: added "Expires: now" header
	to ensure it gets run each time it's visitted.

	* nsd/serv.c (NsConnArgProc): Race condition when threads
	exit while [ns_info threads] is run; arg can be NULL.  Seen
	mostly by people who regularly visit nstelemetry.adp.
	(AppendConn): same thing but with connPtr.  This may be a
	losing battle.  It appears to work on a busy Irix server,
	so I'm declaring victory for now.

2000-09-28  Jim Davidson
	
	* nssock/sock.c: Fixed bufferred read code in SockRead,
	resulting in a big performance boost and system load
	reduction.  Special thanks to Zachary Girouard.

2000-09-05  Kris Rehberg 

	*** AOLserver 3.1 Released *** 

2000-09-05  (various: Jerry Asher, Jim Davidson, "Dossy," Curtis Galloway,
	Scott S. Goodwin, Rob Mayoff, Kris Rehberg)

	* thread/win32.cpp: Sets thread stack size as on other
	platforms.

	* thread/thread.c: NULL out thread arg at exit to avoid
	Ns_ThreadEnum checking arg info for possibly deallocated
	context as seen in ns_info threads.  Also, moved read of
	firstPtr in Ns_ThreadEnum inside lock.  Added Ns_ThreadCreate2
	in thread.c needed for upgrade to Tcl 8.3.1 in tcl8x.c
	
	* thread/pthread.cpp: ETIME bug work around not causes
	wakeup in Ns_CondWait and Ns_CondTimeWait instead of waiting
	again.  This is more conservative and should avoid problems
	some have had with threads missing wakeup.

	* thread/pool.c: Added a simple 1-byte range check to -z
	allocator.

	* thread/Makefile: Added dependency for osthread.o to
	Makefile.

	* tcl/namespace.tcl: Added namespace export to init script.

	* nsvhr/nsvhr.c: Switched to Ns_WriteConn in TimedSockDump
	to ensure all data was sent.

	* nssock(nsssl): SSL module includes a fake 40-bit/512-bit
	export-grade SSL keyfile.pem and certfile.pem for immediate
	use on installation.  Adjusted for use with BSAFE 4 and 5.

	* nspd: Library now installed to binary distribution.

	* nsd/tclsock.c: Fixed crash bug in error message in
	ns_socknread.

	* nsd/tclcmds.c: Added ns_adp_registertag command as
	documented.
	
	* nsd/serv.c: Added missing break for unauthorized case in
	ConnRun.

	* nsd/random.c: Fixed deadlock between Ns_DRand/Ns_GenSeeds.
	
	* nsd/nsmain.c: Fixed some message formatting problems.

	* nsd/mimetypes.c: Added .png type, "image/png".
	
	* nsd/dbtcl.c: Removed unused variables in GetCsvCmd.  Use
	a dstring to create the column list instead of incrementally
	setting the output variable with Tcl_SetVar.  This was
	necessary to avoid conflicting definitions of the needed
	TCL_ flags between 7.6 and 8.x.

	* nsd/dbinit.c: MOdified current per-thread handle count
	to use a single TLS slot instead of a slot per pool.
	
	* nsd/tclinit.c,adp.c,conn.c: The use of thread-local
	storage (Tls) is now self-initializing in the conn, ADP,
	Tcl, etc.  This allows ns_conn commands to be used outside
	a connection thread as well as other uses of Tls where it
	may not be ready for use.

	* nscp/nscp.c: Password non-echo code confuses Win32 and
	some free Unix telnet clients so it has been disabled by
	default for now, though it can be enabled by setting
	"echopassword" in the nscp module section of nsd.tcl.
	
2000-08-21  Kris Rehberg 

	* nscp/nscp.c: Makes some attempt to recognize and handle
	telnet IAC codes like CTRL-C and CTRL-D to force a logout.
	This implementation of the telnet protocol is dirt-cheap,
	so only standard Unix telnet is supported.  On Win32, IAC
	handling is completely disabled because the client is too
	chatty with its IAC codes.

2000-08-20  Kris Rehberg 

	* nsftp, nspostgres, nssolid, nssybpd moved to $TOP level.

2000-08-17  Jim Davidson

	* nsd/dbtcl: Removed unused variables in GetCsvCmd.
	
	* nsd/adp.c: Fixed bug of not truncating output buffer when
	an error was thrown during an ns_adp_parse.  Fix suggested
	by Rob Mayoff.

	* tcl7.6 and tcl8.2.3: Switched to blocking Tcl_WaitPid to
	avoid zombies as suggested by Rob Mayoff.
	
	* thread: NULL out thread arg at exit to avoid Ns_ThreadEnum
	checking arg info for possibly deallocated context as seen
	in ns_info threads.  Also, moved read of firstPtr in
	Ns_ThreadEnum inside lock.
	
2000-08-17  Kris Rehberg 
	
	* nssock/sock.c (SockThread): warning sent to log when
	Server Busy is returned.

	* All the Makefiles should be in line with each other.
	Typing "gmake", "gmake install" and "gmake clean" should
	work in any directory.  NSHOME is paid attention to by all
	Makefiles.

	* nsd: Ns_Log and Ns_Fatal statements are hopefully more
	standardized and more useful to admins and developers.

	* Irix now builds as -o32 using the native compiler by
	default.  See Makefile.global on how to change.

2000-08-15  Kris Rehberg 

	* include/Makefile.global (INSTLOG): should have pointed
	to $(INST)/lib, not $(INST)/modules/lib.

	* Makefile: nsunix resurrected.  All modules are built.
	If a module is missing a library, it is not built, but it
	won't stop the AOLserver build process (no error is thrown).
	The build will continue with the next module.
	
	* nsftp: guesses if you have TCP_WRAPPERS available.

	* nsext: Ten guesses why $(NSHOME)/include/nsextmsg.h was
	duplicated here.

	* nssybpd: Hopefully, the log statements will be easier to
	understand by both admins and developers.  It's still messy
	since it uses syslog.  Makefile redone to use standard
	AOLserver rules.  RPATH is used a little more intelligently.
	Removed files that had no business living there.
	
	* include/Makefile.global: Took stab at RPATH support on
	Solaris to perhaps remove the need for LD_LIBRARY_PATH on
	an intelligenly-administered system.  New rule for libnspd.a.
	
	
2000-08-14  Kris Rehberg 

	* Makefile: nsvhr has been resurrected and enjoys our full
	support.

	* nsexample/Makefile: The include at the bottom wasn't using
	$(NSHOME).

2000-08-14  Jim Davidson

	* Tcl 8.x library upgraded to tcl8.3.2.

	* thread/pool.c: A spiffy range-checker added to the Zippy
	(-z) memory allocator.

2000-08-11  Kris Rehberg 

	* nsvhr/nsvhr.c: Always add "Connection: close" to the
	request line to satisfy HTTP 1.1 RFC -- this would break
	MSIE in HTTP 1.1 mode.  HTTP_EOL of "\r\n" used on all
	request lines for stupid web servers on the other end.
	Protocol "tcp" added as synonym of "http" for old-time Unix
	heads.  Lots of folks lended a hand on this one -- Satyam
	Priyadarshy, Jerry Asher, Kriston Rehberg, and special
	thanks to Wanda G. at AOL for adding a CNAME in DNS so
	quickly.

2000-08-09  Kris Rehberg 

	* nsd/serv.c: A whole lot less chatty about conns starting
	and exiting.  If you want to see them, turn on the Debug
	flag.

	* doc/*: lots of updates.  Title page extremely simplified.
	SSL docs updated.  Release notes updated.  NSV docs corrected
	(thanks to Todd Levy.

2000-08-09  Jim Davidson
	
	* tcl7.6/generic/tclFHandle.c: Removed needed fileTable
	which could result in crashes when fd's where reused quickly
	[fixes a rare multiple-exec crashing bug in nsd76 --kris].

	* thread/tcl8x.c: Added a wrapper startup for Tcl_CreateThread
	for the benefit of Win32.

	* nsd/log.c: Removed severityRank array.

	* nsd/tclmisc.c: Fixed bug with ns_info pid. [I can't code --kris]
	
	* nsd: keepalive.c,nsmain.c,sched.c,serv.c: Re-ordered
	shutdowns to ensure connection threads are stopped before
	other shutdowns begin (e.g., sched, sockcallback).
	
	* tcl8.3.1 replaces tcl8.3.0.  README.AOLSERVER added to
	tcl8.3.1 directory.  Original copies of changed are named
	*.orig.

	* include/Makefile.global: Build environment now uses gcc
	-shared -nostartfiles as the default LDSO.

	* nsthread/thread.c: Added Ns_ThreadCreate2 with extra
	flags argument used by Tcl_CreateThread to create a detached
	thread.
	
2000-08-06  Scott S. Goodwin

	* nsd/log.c: Segmentation fault was occuring when writing
	to the log file because file pointer was being assigned to
	incorrectly - it wasn't NULL and it wasn't a valid address
	within processes memory. Fixed.

2000-08-06  Scott S. Goodwin

	* nssock: You can now compile with BSAFE versions 4 and 5.
	You'll need to specify the path to your BSAFE libaries and
	the BSAFE version in the nssock/Makefile before compiling.
	If you don't have BSAFE and want to compile without SSL at
	all, edit the toplevel Makefile and take out all the "SSL=1"
	text. The files changed were nssock/Makefile and
	nssock/t_stdlib.c.

2000-08-02  Kris Rehberg 

	* Build process is a little more rule-oriented.  The cleaning
	rules "distclean" and "clobber" were removed.  The Tcl
	libraries are always distcleaned when "gmake clean" is
	invoked.  Rules that can be used as dependencies were made
	for libnsthread and the Tcl libraries -- their names are
	"libnsthread," "libtcl76," and "libtcl8x," respectively.
	PREFIX is now used as the installation directory (along
	with INST), so the more familiar "gmake install
	PREFIX=/usr/local/aolserver" will work.  Additionally,
	gmaking in a subdirectory with dependencies now works.
	
	* nsd/log.c: The sourge of modlog has been removed.  All
	code included with AOLserver that used Ns_ModLog now doesn't.
	Many log statements are now hopefully more standardized.
	This will be a continuing improvement over the next several
	updates.  I would like to use gcc's __FUNCTION__ macro but
	it doesn't work on native compilers, but we may start using
	__LINE__ and __FILE__ instead or replace Ns_Log with a
	smart macro that takes care of all this stuff for us.

	* nsd/tclmisc.c (NsTclInfoCmd): ns_info pid added to return
	the process id.

2000-08-01  Kris Rehberg 

	* nsd/adp.c (Ns_AdpRequest): The enableexpire option was
	putting an Expires header even if it already existed.

	* nsd/return.c (Ns_ConnReturnNotice): Yikes, /face should
	have been /font.  No more fonts, colors, etc, on default
	notice pages.

	* nsd/tclsock.c (NsTclSockOpenCmd): Removed spurious Ns_Log
	Notice from ns_sockopen.

	* tcl/form.tcl (ns_getform): MSIE presents the wrong stuff
	to the server when a multipart/formdata POST is redirected.
	Workaround contributed by Joseph Bank.

	* tcl/fastpath.tcl (_ns_dirlist): base href removed --
	links are now fully-qualified.

	* Makefile (install): include and lib dirs are now included
	in binary distribution.

	* tcl/http.tcl (_ns_http_gets): \n replaced by \r in all
	but _ns_http_gets so that arbitrary headers get set correctly.

	* tcl7.6/generic/tclPosixStr.c (Tcl_SignalMsg): Patch to
	Tcl 7.6 for Red Hat on SPARC architectures.  Contributed
	by Mike Chan.

2000-07-13  Kris Rehberg 

	* scripts/nsd.tcl: nssslmodule names the nsssl/nsssle
	binary's filename.  nscp_port tells nscp what port to
	listen.

	* nssock: nssock.c renamed sock.c, SSL support has been
	merged back with nssock so that both nsssl and nssock use
	identical socket code.
	
	* nsssl2: directory removed; nsssl is in the nssock directory
	now.

2000-05-09  Kris Rehberg 

	* Re-added doc directory which has had the online docs
	removed.

2000-05-02  Kris Rehberg 

	* Makefile, include/Makefile.global, include/Makefile.module,
	nsexample/Makefile: Now uses NSHOME variable to locate
	AOLserver.  NSHOME is automatically figured out in the
	top-level Makefile and all the lower Makefiles still use
	relative directory paths.  The intention of NSHOME is for
	modules that do NOT live in the AOLserver source directory
	tree.  The nsexample/Makefile explains how this works.

	* nsftp module added.  Contributed by Eric O'Laughlen.

2000-04-12  Kris Rehberg 

	*** AOLserver 3.0 FINAL Released ***
	
